﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Net;
using ICallisto;

namespace CallistoX
{
    class AdminLog
    {
        private static List<LogSendItem> items = new List<LogSendItem>();

        public static void AddToLogSend(IUser userobj)
        {
            if (items.Find(x => x.Guid == userobj.Guid && x.IP.Equals(userobj.ExternalIP)) == null)
            {
                items.Add(new LogSendItem
                {
                    Guid = userobj.Guid,
                    IP = userobj.ExternalIP
                });

                if (StringTemplate.GetString(STType.AdminMessages, 11) != null)
                    Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 11).Replace("+n", userobj.Name), true);
            }
        }

        public static void RemoveFromLogSend(IUser userobj, bool show)
        {
            items.RemoveAll(x => x.Guid == userobj.Guid && x.IP.Equals(userobj.ExternalIP));

            if (show)
                if (StringTemplate.GetString(STType.AdminMessages, 12) != null)
                    Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 12).Replace("+n", userobj.Name), true);
        }

        public static void ShowLog()
        {
            try
            {
                Process.Start("notepad.exe", Callisto.DataPath + "adminlog.txt");
            }
            catch { }
        }

        public static void AddLine(String text)
        {
            StreamWriter s;

            try
            {
                if (!File.Exists(Callisto.DataPath + "adminlog.txt"))
                    s = File.CreateText(Callisto.DataPath + "adminlog.txt");
                else
                    s = File.AppendText(Callisto.DataPath + "adminlog.txt");

                s.WriteLine(TimeString() + " " + text);
                s.Flush();
                s.Close();
            }
            catch { }

            ShowToAdmins(TimeString() + " " + text);
        }

        private static void ShowToAdmins(String text)
        {
            for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                if (u.Level > AdminLevel.Regular)
                    if (items.Find(x => x.Guid == u.Guid && x.IP.Equals(u.ExternalIP)) != null)
                        Callisto.SendPM(u, Callisto.Room.BotName, "LOG: " + text);
        }

        private static String TimeString()
        {
            DateTime d = DateTime.Now;
            return d.ToShortTimeString();
        }
    }

    class LogSendItem
    {
        public IPAddress IP { get; set; }
        public String Guid { get; set; }
    }
}
