﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using ICallisto;

namespace CallistoX
{
    class CmdLevelManager
    {
        private static List<CmdItem> items = new List<CmdItem>();

        public static void SetValues(DataGridView grid)
        {
            items.Add(new CmdItem { Name = Cmd.muzzle, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.unmuzzle, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.kill, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.ban, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.clone, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.changename, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.oldname, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.move, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.whois, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.kiddy, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.unkiddy, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.paint, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.unpaint, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.echo, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.unecho, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.lower, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.unlower, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.redirect, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.listbans, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.unban, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.listrangebans, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.rangeban, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.rangeunban, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.urban, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.define, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.trace, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.customnames, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.general, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.caps, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.colors, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.lastseen, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.idle, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.shout, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.announce, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.admins, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.adminmsg, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.stats, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.whowas, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.roomsearch, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.mtimeout, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.clock, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.bansend, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.logsend, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.stealth, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.ipsend, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.sharefiles, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.anon, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.topic, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.url, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.addurl, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.remurl, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.listurl, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.greetmsg, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.pmgreetmsg, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.setpmgreetmsg, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.addgreetmsg, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.remgreetmsg, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.listgreetmsg, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.vspy, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.translate, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.untranslate, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.listlang, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.adminannounce, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.addwordfilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.remwordfilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.addline, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.editline, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.remline, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.viewfilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.wordfilters, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.filter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.addjoinfilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.remjoinfilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.joinfilters, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.addfilefilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.remfilefilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.filefilters, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.addpmfilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.rempmfilter, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.pmfilters, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.banstats, Level = AdminLevel.Administrator });
            items.Add(new CmdItem { Name = Cmd.linkinfo, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.link, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.unlink, Level = AdminLevel.Host });
            items.Add(new CmdItem { Name = Cmd.cloak, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.clearscreen, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.disableavatar, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.enableavatar, Level = AdminLevel.Moderator });
            items.Add(new CmdItem { Name = Cmd.weather, Level = AdminLevel.Moderator });

            try
            {
                FileStream f = new FileStream(Callisto.DataPath + "levels.xml", FileMode.Open);
                XmlReader xml = XmlReader.Create(new StreamReader(f));

                xml.MoveToContent();
                xml.ReadSubtree().ReadToFollowing("levels");

                while (xml.ReadToFollowing("item"))
                {
                    xml.ReadSubtree().ReadToFollowing("name");
                    String n = xml.ReadElementContentAsString();
                    xml.ReadToFollowing("level");
                    String l = xml.ReadElementContentAsString();

                    if (Enum.IsDefined(typeof(Cmd), n))
                        if (Enum.IsDefined(typeof(AdminLevel), l))
                            items.Find(x => x.Name == (Cmd)Enum.Parse(typeof(Cmd), n)).Level = (AdminLevel)Enum.Parse(typeof(AdminLevel), l);
                }

                xml.Close();
                f.Flush();
                f.Close();
            }
            catch { }

            foreach (CmdItem i in items)
                AddItemToGrid(grid, i);
        }

        public static void UpdateItem(String cmd, String level)
        {
            if (Enum.IsDefined(typeof(Cmd), cmd))
            {
                if (Enum.IsDefined(typeof(AdminLevel), level))
                {
                    AdminLevel now = items.Find(x => x.Name == (Cmd)Enum.Parse(typeof(Cmd), cmd)).Level;
                    AdminLevel after = (AdminLevel)Enum.Parse(typeof(AdminLevel), level);

                    if (!now.Equals(after))
                    {
                        items.Find(x => x.Name == (Cmd)Enum.Parse(typeof(Cmd), cmd)).Level = after;
                        Save();
                    }
                }
            }
        }

        public static AdminLevel GetLevel(Cmd cmd)
        {
            return items.Find(x => x.Name == cmd).Level;
        }

        private static void AddItemToGrid(DataGridView grid, CmdItem item)
        {
            grid.Rows.Add();
            grid.Rows[grid.Rows.Count - 1].Cells[0].Value = "#" + item.Name.ToString();
            DataGridViewComboBoxCell cb = (DataGridViewComboBoxCell)grid.Rows[grid.Rows.Count - 1].Cells[1];
            cb.Items.AddRange(new String[] { "Moderator", "Administrator", "Host" });
            cb.Value = item.Level.ToString();
        }

        private static void Save()
        {
            try
            {
                XmlWriterSettings appearance = new XmlWriterSettings();
                appearance.Indent = true;
                XmlWriter xml = XmlWriter.Create(Callisto.DataPath + "levels.xml", appearance);

                xml.WriteStartDocument();
                xml.WriteStartElement("levels");

                foreach (CmdItem a in items)
                {
                    xml.WriteStartElement("item");
                    xml.WriteElementString("name", a.Name.ToString());
                    xml.WriteElementString("level", a.Level.ToString());
                    xml.WriteEndElement();
                }

                xml.WriteEndElement();
                xml.WriteEndDocument();
                xml.Flush();
                xml.Close();
            }
            catch { }
        }
    }

    enum Cmd
    {
        muzzle, unmuzzle, kill, ban, clone,
        changename, oldname, move, whois, kiddy,
        unkiddy, paint, unpaint, echo, unecho,
        lower, unlower, redirect, listbans, unban,
        listrangebans, rangeban, rangeunban, urban, customnames,
        general, caps, colors, lastseen, idle,
        shout, announce, admins, adminmsg, stats,
        whowas, roomsearch, mtimeout, clock, bansend,
        logsend, stealth, ipsend, sharefiles, anon,
        topic, url, greetmsg, pmgreetmsg, addgreetmsg,
        remgreetmsg, setpmgreetmsg, listgreetmsg, addurl, remurl,
        listurl, vspy, define, trace, translate,
        untranslate, listlang, adminannounce, addwordfilter, remwordfilter,
        addline, editline, remline, viewfilter, wordfilters,
        filter, addjoinfilter, remjoinfilter, joinfilters, addfilefilter,
        remfilefilter, filefilters, addpmfilter, rempmfilter, pmfilters,
        banstats, linkinfo, link, unlink, cloak,
        clearscreen, disableavatar, enableavatar, weather
    }

    class CmdItem
    {
        public Cmd Name { get; set; }
        public AdminLevel Level { get; set; }
    }
}
