﻿using System;
using ICallisto;

namespace CallistoX
{
    class CmdProcessor
    {
        private static UrbanDictionary urban = new UrbanDictionary();
        private static Define define = new Define();
        private static Trace trace = new Trace();
        private static Weather weather = new Weather();

        public static void DisableAvatar(IUser admin, IUser target)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;
            DefaultAvatar.AddRemAvatar(target);

            if (StringTemplate.GetString(STType.AdminCommands, 25) != null)
                Callisto.Print(StringTemplate.GetString(STType.AdminCommands, 25).Replace("+n", _admin).Replace("+t", target.Name));

            AdminLog.AddLine(target.Name + " avatar disabled by " + admin.Name);
        }

        public static void EnableAvatar(IUser admin, IUser target)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;
            DefaultAvatar.RemRemAvatar(target);

            if (StringTemplate.GetString(STType.AdminCommands, 26) != null)
                Callisto.Print(StringTemplate.GetString(STType.AdminCommands, 26).Replace("+n", _admin).Replace("+t", target.Name));

            AdminLog.AddLine(target.Name + " avatar enabled by " + admin.Name);
        }

        public static void ClearScreen(IUser admin)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            for (int i = 0; i < 500; i++)
                Callisto.Print(admin.Vroom, String.Empty);

            if (StringTemplate.GetString(STType.AdminCommands, 24) != null)
                Callisto.Print(StringTemplate.GetString(STType.AdminCommands, 24).Replace("+n", _admin));

            AdminLog.AddLine("screen cleared by " + admin.Name);
        }

        public static void CloakOn(IUser admin, String args)
        {
            if (args == "on" && !admin.Cloaked)
            {
                admin.Cloaked = true;
                String str = StringTemplate.GetString(STType.Cloak, 0);

                if (str != null)
                    Callisto.PrintToAdmins(str.Replace("+n", admin.Name));
            }
            else if (args == "off" && admin.Cloaked)
            {
                admin.Cloaked = false;
                String str = StringTemplate.GetString(STType.Cloak, 1);

                if (str != null)
                    Callisto.PrintToAdmins(str.Replace("+n", admin.Name));
            }
        }

        public static void TopicClockOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.TopicClock)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 0);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("topic clock enabled by " + admin.Name);
                Settings.TopicClock = true;
                Topics.ForceClock(true);
            }

            if (args == "off" && Settings.TopicClock)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 1);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("topic clock disabled by " + admin.Name);
                Settings.TopicClock = false;
                Topics.ForceClock(false);
            }
        }

        public static void AdminAnnounceOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.AdminAnnounceOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 2);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("admin announce filters enabled by " + admin.Name);
                Settings.AdminAnnounceOn = true;
            }

            if (args == "off" && Settings.AdminAnnounceOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 3);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("admin announce filters disabled by " + admin.Name);
                Settings.AdminAnnounceOn = false;
            }
        }

        public static void FiltersOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.FiltersOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 4);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("filters enabled by " + admin.Name);
                Settings.FiltersOn = true;
            }

            if (args == "off" && Settings.FiltersOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 5);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("filters disabled by " + admin.Name);
                Settings.FiltersOn = false;
            }
        }

        public static void HistoryOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.HistoryOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 6);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("chat history enabled by " + admin.Name);
                Settings.HistoryOn = true;
            }

            if (args == "off" && Settings.HistoryOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 7);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("chat history disabled by " + admin.Name);
                Settings.HistoryOn = false;
            }
        }

        public static void GeneralOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.GeneralOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 8);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("general commands enabled by " + admin.Name);
                Settings.GeneralOn = true;
            }

            if (args == "off" && Settings.GeneralOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 9);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("general commands disabled by " + admin.Name);
                Settings.GeneralOn = false;
            }
        }

        public static void VspyOn(IUser admin, String args)
        {
            if (args == "on")
                VSpy.AddUser(admin);

            if (args == "off")
                VSpy.RemoveUser(admin, false);
        }

        public static void CapsOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.CapsOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 10);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("caps monitoring enabled by " + admin.Name);
                Settings.CapsOn = true;
            }

            if (args == "off" && Settings.CapsOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 11);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("caps monitoring disabled by " + admin.Name);
                Settings.CapsOn = false;
            }
        }

        public static void ColorsOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.ColorsOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 12);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("color text enabled by " + admin.Name);
                Settings.ColorsOn = true;
            }

            if (args == "off" && Settings.ColorsOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 13);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("color text disabled by " + admin.Name);
                Settings.ColorsOn = false;
            }
        }

        public static void LastSeenOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.LastSeenOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 14);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("last seen monitoring enabled by " + admin.Name);
                Settings.LastSeenOn = true;
            }

            if (args == "off" && Settings.LastSeenOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 15);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("last seen monitoring disabled by " + admin.Name);
                Settings.LastSeenOn = false;
            }
        }

        public static void CustomNamesOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.CustomNamesOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 16);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("custom names enabled by " + admin.Name);
                Settings.CustomNamesOn = true;
                Callisto.Room.CustomName = true;
            }

            if (args == "off" && Settings.CustomNamesOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 17);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("custom names disabled by " + admin.Name);
                Settings.CustomNamesOn = false;
                Callisto.Room.CustomName = false;
            }
        }

        public static void IPSendOn(IUser admin, String args)
        {
            if (args == "on" && IPSendManager.AddIPSend(admin))
                if (StringTemplate.GetString(STType.AdminMessages, 0) != null)
                    Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 0).Replace("+n", admin.Name), true);

            if (args == "off" && IPSendManager.RemoveIPSend(admin))
                if (StringTemplate.GetString(STType.AdminMessages, 1) != null)
                    Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 1).Replace("+n", admin.Name), true);
        }

        public static void BanSendOn(IUser admin, String args)
        {
            if (args == "on" && BanManager.AddBanSend(admin))
                if (StringTemplate.GetString(STType.AdminMessages, 2) != null)
                    Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 2).Replace("+n", admin.Name), true);

            if (args == "off" && BanManager.RemoveBanSend(admin))
                if (StringTemplate.GetString(STType.AdminMessages, 3) != null)
                    Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 3).Replace("+n", admin.Name), true);
        }

        public static void LogSendOn(IUser admin, String args)
        {
            if (args == "on")
                AdminLog.AddToLogSend(admin);

            if (args == "off")
                AdminLog.RemoveFromLogSend(admin, true);
        }

        public static void IdleOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.IdleOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 18);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("idle monitoring enabled by " + admin.Name);
                Settings.IdleOn = true;
            }

            if (args == "off" && Settings.IdleOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 19);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("idle monitoring disabled by " + admin.Name);
                Settings.IdleOn = false;
            }
        }

        public static void ShareFileOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.ShareOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 20);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("share files monitoring enabled by " + admin.Name);
                Settings.ShareOn = true;
            }

            if (args == "off" && Settings.ShareOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 21);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("share files monitoring disabled by " + admin.Name);
                Settings.ShareOn = false;
            }
        }

        public static void AnonOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.AnonOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 22);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("anon monitoring enabled by " + admin.Name);
                Settings.AnonOn = true;
            }

            if (args == "off" && Settings.AnonOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 23);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("anon monitoring disabled by " + admin.Name);
                Settings.AnonOn = false;
            }
        }

        public static void StealthOn(IUser admin, String args)
        {
            if (args == "on" && !Settings.StealthOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 24);

                if (str != null)
                    Callisto.Print(str.Replace("+n", admin.Name), true);

                AdminLog.AddLine("stealth mode enabled by " + admin.Name);
                Settings.StealthOn = true;
            }

            if (args == "off" && Settings.StealthOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 25);

                if (str != null)
                    Callisto.Print(str.Replace("+n", admin.Name), true);

                AdminLog.AddLine("stealth mode disabled by " + admin.Name);
                Settings.StealthOn = false;
            }
        }

        public static void Shout(IUser userobj, String args)
        {
            if (StringTemplate.GetString(STType.AdminMessages, 4) != null)
                Callisto.Print(StringTemplate.GetString(STType.AdminMessages, 4).Replace("+n", userobj.Name).Replace("+x", args));
        }

        public static void Whisper(IUser userobj, IUser target, String args)
        {
            if (StringTemplate.GetString(STType.AdminMessages, 5) != null)
            {
                bool success = true;
                
                if (userobj.Level == AdminLevel.Regular)
                    success = WordFilter.FilterWhisper(args);

                if (success)
                {
                    Callisto.Print(userobj, StringTemplate.GetString(STType.AdminMessages, 5).Replace("+n", userobj.Name).Replace("+t", target.Name).Replace("+x", args));
                    Callisto.Print(target, StringTemplate.GetString(STType.AdminMessages, 5).Replace("+n", userobj.Name).Replace("+t", target.Name).Replace("+x", args));
                }
            }
        }

        public static void Google(IUser userobj, String args)
        {
            String lang = "en"; // english default

            switch (Callisto.Room.Language)
            {
                case Language.Arabic:
                    lang = "ar"; break;

                case Language.Chinese:
                    lang = "zh-CN"; break;

                case Language.Czech:
                    lang = "cs"; break;

                case Language.Danish:
                    lang = "da"; break;

                case Language.Dutch:
                    lang = "nl"; break;

                case Language.Finnish:
                    lang = "fi"; break;

                case Language.German:
                    lang = "de"; break;

                case Language.Italian:
                    lang = "it"; break;

                case Language.Japanese:
                    lang = "ja"; break;

                case Language.Polish:
                    lang = "pl"; break;

                case Language.Portuguese:
                    lang = "pt-PT"; break;

                case Language.Russian:
                    lang = "ru"; break;

                case Language.Slovak:
                    lang = "sk"; break;

                case Language.Spanish:
                    lang = "es"; break;

                case Language.Swedish:
                    lang = "sv"; break;

                case Language.Turkish:
                    lang = "tr"; break;
            }
            
            Callisto.Print(userobj.Vroom, "\x000314Google (" + userobj.Name + "): http://www.google.com/search?hl=" + lang + "&q=" + Uri.EscapeDataString(args));
        }

        public static void Info(IUser userobj, bool pm)
        {
            if (StringTemplate.GetString(STType.Info, 0) != null)
            {
                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (pm)
                        userobj.SendPM(Callisto.Room.BotName, StringTemplate.GetString(STType.Info, 0).Replace("+id", u.Id.ToString()).Replace("+n", u.Name).Replace("+v", u.Vroom.ToString()));
                    else
                        Callisto.Print(userobj, StringTemplate.GetString(STType.Info, 0).Replace("+id", u.Id.ToString()).Replace("+n", u.Name).Replace("+v", u.Vroom.ToString()));
            }
        }

        public static void Urban(IUser userobj, String query)
        {
            urban.Query(userobj.Vroom, query);
        }

        public static void Define(IUser userobj, String query)
        {
            define.Query(userobj.Vroom, query);
        }

        public static void Trace(IUser userobj, IUser target)
        {
            trace.Query(userobj.Vroom, target);
        }

        public static void GetWeather(IUser userobj, IUser target)
        {
            weather.Query(userobj.Vroom, target);
        }

        public static void Trace(IUser userobj, String args)
        {
            trace.QueryByIP(userobj.Vroom, args);
        }

        public static void RoomSearch(IUser userobj, String query)
        {
            Callisto.RoomSearch.Query(userobj.Vroom, query);
        }

        public static void ClearBans(IUser admin, bool host)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            MuzzleManager.Clear();
            Callisto.ClearBans();
            KiddyManager.Clear();
            EchoManager.Clear();
            LowerManager.Clear();
            RangeBanManager.Clear();

            if (!host)
                if (StringTemplate.GetString(STType.AdminCommands, 0) != null)
                    Callisto.Print(StringTemplate.GetString(STType.AdminCommands, 0).Replace("+n", _admin), true);

            AdminLog.AddLine(admin.Name + " has cleared all the ban lists");
        }

        public static void Redirect(IUser admin, IUser target, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;
            IChannelObject ch = Callisto.Hashlink.Decode(args);

            if (ch != null)
            {
                String str = StringTemplate.GetString(STType.AdminCommands, 1);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin).Replace("+t", target.Name).Replace("+x", ch.Name), true);

                AdminLog.AddLine(admin.Name + " has redirected " + target.Name + " to " + ch.Name);
                target.Redirect(args);
            }
        }

        public static void ListAdmins(IUser userobj)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : userobj.Name;

            if (StringTemplate.GetString(STType.AdminList, 0) != null)
            {
                Callisto.Print(StringTemplate.GetString(STType.AdminList, 0).Replace("+n", _admin), true);
                Callisto.Print("", true);
            }

            if (StringTemplate.GetString(STType.AdminList, 1) != null)
            {
                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (u.Level > AdminLevel.Regular)
                        Callisto.Print(StringTemplate.GetString(STType.AdminList, 1).Replace("+n", u.Name).Replace("+l", ((int)u.Level).ToString()), true);

                if (Callisto.Linker.IsLinked)
                    for (IUser u = Callisto.FirstLinked; u != null; u = u.NextUser)
                        if (u.Level > AdminLevel.Regular)
                            Callisto.Print(StringTemplate.GetString(STType.AdminList, 1).Replace("+n", u.Name).Replace("+l", "L"), true);
            }

            if (StringTemplate.GetString(STType.AdminList, 2) != null)
            {
                Callisto.Print("", true);
                Callisto.Print(StringTemplate.GetString(STType.AdminList, 2).Replace("+n", _admin), true);
            }
        }

        public static void Stats(IUser userobj)
        {
            if (StringTemplate.GetString(STType.Stats, 0) != null)
            {
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 0).Replace("+x", Callisto.Room.Name));
                Callisto.Print(userobj, "");
            }

            if (StringTemplate.GetString(STType.Stats, 1) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 1).Replace("+x", Callisto.Room.Language.ToString()));
            if (StringTemplate.GetString(STType.Stats, 2) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 2).Replace("+x", Callisto.Room.Hashlink));
            if (StringTemplate.GetString(STType.Stats, 3) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 3).Replace("+x", Helpers.GetUptime(Callisto.Room.StartTime)));
            if (StringTemplate.GetString(STType.Stats, 4) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 4).Replace("+x", Callisto.Stats.DataReceived.ToString()));
            if (StringTemplate.GetString(STType.Stats, 5) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 5).Replace("+x", Callisto.Stats.DataSent.ToString()));
            if (StringTemplate.GetString(STType.Stats, 6) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 6).Replace("+x", Callisto.Stats.InvalidLoginAttempts.ToString()));
            if (StringTemplate.GetString(STType.Stats, 7) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 7).Replace("+x", Callisto.Stats.FloodCount.ToString()));
            if (StringTemplate.GetString(STType.Stats, 8) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 8).Replace("+x", Callisto.Stats.RejectionCount.ToString()));
            if (StringTemplate.GetString(STType.Stats, 9) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 9).Replace("+x", Callisto.Stats.JoinCount.ToString()));
            if (StringTemplate.GetString(STType.Stats, 10) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 10).Replace("+x", Callisto.Stats.PartCount.ToString()));
            if (StringTemplate.GetString(STType.Stats, 11) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 11).Replace("+x", Callisto.Stats.CurrentUserCount.ToString()));
            if (StringTemplate.GetString(STType.Stats, 12) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 12).Replace("+x", Callisto.Stats.PeakUserCount.ToString()));
            if (StringTemplate.GetString(STType.Stats, 13) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 13).Replace("+x", Callisto.Stats.PublicMessages.ToString()));
            if (StringTemplate.GetString(STType.Stats, 14) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 14).Replace("+x", Callisto.Stats.PrivateMessages.ToString()));
            if (StringTemplate.GetString(STType.Stats, 15) != null)
                Callisto.Print(userobj, StringTemplate.GetString(STType.Stats, 15).Replace("+x", Callisto.RoomSearch.DBSize.ToString()));
        }

        public static void Whois(IUser admin, IUser target)
        {
            if (StringTemplate.GetString(STType.Whois, 0) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 0).Replace("+x", target.Name));
            if (StringTemplate.GetString(STType.Whois, 1) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 1).Replace("+x", target.OrgName));
            if (StringTemplate.GetString(STType.Whois, 2) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 2).Replace("+x", target.ExternalIP.ToString()));
            if (StringTemplate.GetString(STType.Whois, 3) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 3).Replace("+x", target.LocalIP.ToString()));
            if (StringTemplate.GetString(STType.Whois, 4) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 4).Replace("+x", target.Port.ToString()));
            if (StringTemplate.GetString(STType.Whois, 5) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 5).Replace("+x", target.Version));
            if (StringTemplate.GetString(STType.Whois, 6) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 6).Replace("+x", target.Vroom.ToString()));
            if (StringTemplate.GetString(STType.Whois, 7) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 7).Replace("+x", target.Id.ToString()));
            if (StringTemplate.GetString(STType.Whois, 8) != null)
                Callisto.Print(admin, StringTemplate.GetString(STType.Whois, 8).Replace("+x", (target.IsLinked ? "Yes" : "No")));

            AdminLog.AddLine(admin.Name + " requested whois for " + target.Name);
        }

        public static void Clone(IUser admin, IUser target, String text, bool host)
        {
            if (String.IsNullOrEmpty(text))
                return;

            if (text.StartsWith("/me "))
                target.SendEmote(text.Substring(4));
            else
                target.SendText(text);

            if (!host)
            {
                String str = StringTemplate.GetString(STType.AdminMessages, 6);

                if (str != null)
                    Callisto.PrintToAdmins(str.Replace("+n", admin.Name).Replace("+t", target.Name), true);
            }

            AdminLog.AddLine(admin.Name + " cloned " + target.Name);
        }

        public static void Announce(IUser admin, String text)
        {
            Callisto.Print(admin.Vroom, text, admin.Vroom == 0);
            String str = StringTemplate.GetString(STType.AdminMessages, 7);

            if (str != null)
                Callisto.PrintToAdmins(str.Replace("+n", admin.Name), admin.Vroom == 0);
        }

        public static void Move(IUser admin, IUser target, ushort vroom)
        {
            target.Vroom = vroom;
            String str = StringTemplate.GetString(STType.AdminMessages, 8);

            if (str != null)
                Callisto.PrintToAdmins(str.Replace("+n", admin.Name).Replace("+t", target.Name).Replace("+x", target.Vroom.ToString()), true);

            AdminLog.AddLine(admin.Name + " moved " + target.Name + " to vroom " + target.Vroom);
        }

        public static void ChangeName(IUser admin, IUser target, String args)
        {
            String orgname = target.Name;
            target.Name = args;
            String str = StringTemplate.GetString(STType.AdminMessages, 9);

            if (str != null)
                Callisto.PrintToAdmins(str.Replace("+n", admin.Name).Replace("+t", orgname).Replace("+x", target.Name), true);

            AdminLog.AddLine(admin.Name + " changed " + orgname + "'s name to " + target.Name);
        }

        public static void OldName(IUser admin, IUser target)
        {
            target.Name = target.OrgName;
            String str = StringTemplate.GetString(STType.AdminMessages, 10);

            if (str != null)
                Callisto.PrintToAdmins(str.Replace("+n", admin.Name).Replace("+t", target.Name), true);

            AdminLog.AddLine(admin.Name + " restored " + target.Name + "'s name");
        }
    }
}
