﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using ICallisto;

namespace CallistoX
{
    class GreetMsg
    {
        private static List<String> items = new List<String>();
        private static Random rnd = new Random();

        public static void ListGreetMsg(IUser userobj)
        {
            for (int i = 0; i < items.Count; i++)
                Callisto.Print(userobj, i + " - " + items[i]);
        }

        public static void AddGreetMsg(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;
            items.Add(args);
            Save();
            String str = StringTemplate.GetString(STType.Greetings, 0);

            if (str != null)
                Callisto.Print(str.Replace("+n", _admin), true);

            AdminLog.AddLine("greet message added by " + admin.Name);
        }

        public static void RemGreetMsg(IUser admin, int ident)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (ident < 0 || ident >= items.Count)
                return;

            items.RemoveAt(ident);
            Save();
            String str = StringTemplate.GetString(STType.Greetings, 1);

            if (str != null)
                Callisto.Print(str.Replace("+n", _admin), true);

            AdminLog.AddLine("greet message removed by " + admin.Name);
        }

        public static void SetPMGreetMsg(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;
            Settings.PMGreetMsg = args;
            String str = StringTemplate.GetString(STType.Greetings, 2);

            if (str != null)
                Callisto.Print(str.Replace("+n", _admin), true);

            AdminLog.AddLine("pm greet message set by " + admin.Name);
        }

        public static void PMGreetMsgOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.PMGreetMsgOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 28);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("pm greet message enabled by " + admin.Name);
                Settings.PMGreetMsgOn = true;
            }

            if (args == "off" && Settings.PMGreetMsgOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 29);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("pm greet message disabled by " + admin.Name);
                Settings.PMGreetMsgOn = false;
            }
        }

        public static void GreetMsgOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.GreetMsgOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 30);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("greet message enabled by " + admin.Name);
                Settings.GreetMsgOn = true;
            }

            if (args == "off" && Settings.GreetMsgOn)
            {
                String str = StringTemplate.GetString(STType.EnableDisable, 31);

                if (str != null)
                    Callisto.Print(str.Replace("+n", _admin), true);

                AdminLog.AddLine("greet message disabled by " + admin.Name);
                Settings.GreetMsgOn = false;
            }
        }

        public static void ShowGreetMsg(IUser userobj)
        {
            if (items.Count == 0)
                return;

            String str = items[(int)Math.Floor(rnd.NextDouble() * items.Count)];
            String rnd_user = Helpers.RandomUser(userobj).Name;
            String _str = Helpers.CountryCodeToString(userobj.Country);

            if (_str != "?")
                if (userobj.Region.Length > 0)
                    _str = userobj.Region + ", " + _str;

            if (_str == "?")
                if (userobj.Region.Length > 0)
                    _str = userobj.Region;

            if (_str == "?")
                _str = "unknown";

            str = str.Replace("+n", userobj.Name);
            str = str.Replace("+ip", userobj.ExternalIP.ToString());
            str = str.Replace("+id", userobj.Id.ToString());
            str = str.Replace("+f", userobj.FileCount.ToString());
            str = str.Replace("+v", userobj.Version);
            str = str.Replace("+p", userobj.Port.ToString());
            str = str.Replace("+uc", Callisto.Stats.CurrentUserCount.ToString());
            str = str.Replace("+rn", Callisto.Room.Name);
            str = str.Replace("+ut", Helpers.GetUptime(Callisto.Room.StartTime));
            str = str.Replace("+ru", rnd_user);
            str = str.Replace("+l", _str);
            Callisto.Print(userobj.Vroom, str, userobj.Vroom == 0);
        }

        public static void ShowPMGreetMsg(IUser userobj)
        {
            if (String.IsNullOrEmpty(Settings.PMGreetMsg))
                return;

            String str = Settings.PMGreetMsg;
            String rnd_user = Helpers.RandomUser(userobj).Name;
            String _str = Helpers.CountryCodeToString(userobj.Country);

            if (_str != "?")
                if (userobj.Region.Length > 0)
                    _str = userobj.Region + ", " + _str;

            if (_str == "?")
                if (userobj.Region.Length > 0)
                    _str = userobj.Region;

            if (_str == "?")
                _str = "unknown";

            str = str.Replace("+n", userobj.Name);
            str = str.Replace("+ip", userobj.ExternalIP.ToString());
            str = str.Replace("+id", userobj.Id.ToString());
            str = str.Replace("+f", userobj.FileCount.ToString());
            str = str.Replace("+v", userobj.Version);
            str = str.Replace("+p", userobj.Port.ToString());
            str = str.Replace("+uc", Callisto.Stats.CurrentUserCount.ToString());
            str = str.Replace("+rn", Callisto.Room.Name);
            str = str.Replace("+ut", Helpers.GetUptime(Callisto.Room.StartTime));
            str = str.Replace("+ru", rnd_user);
            str = str.Replace("+l", _str);
            Callisto.SendPM(userobj, Callisto.Room.BotName, str);
        }

        public static void Load()
        {
            try
            {
                FileStream f = new FileStream(Callisto.DataPath + "greetings.xml", FileMode.Open);
                XmlReader xml = XmlReader.Create(new StreamReader(f));

                xml.MoveToContent();
                xml.ReadSubtree().ReadToFollowing("greetings");

                while (xml.ReadToFollowing("item"))
                {
                    xml.ReadSubtree().ReadToFollowing("text");
                    items.Add(Encoding.UTF8.GetString(Convert.FromBase64String(xml.ReadElementContentAsString())));
                }

                xml.Close();
                f.Flush();
                f.Close();
            }
            catch { }
        }

        private static void Save()
        {
            try
            {
                XmlWriterSettings appearance = new XmlWriterSettings();
                appearance.Indent = true;
                XmlWriter xml = XmlWriter.Create(Callisto.DataPath + "greetings.xml", appearance);

                xml.WriteStartDocument();
                xml.WriteStartElement("greetings");

                foreach (String a in items)
                {
                    xml.WriteStartElement("item");
                    xml.WriteElementString("text", Convert.ToBase64String(Encoding.UTF8.GetBytes(a)));
                    xml.WriteEndElement();
                }

                xml.WriteEndElement();
                xml.WriteEndDocument();
                xml.Flush();
                xml.Close();
            }
            catch { }
        }
    }
}
