﻿using System;
using System.Collections.Generic;
using ICallisto;

namespace CallistoX
{
    class IPSendManager
    {
        private static List<int> items = new List<int>();

        public static void IPSend(IUser userobj)
        {
            String str = StringTemplate.GetString(STType.IPSend, 0);

            if (str != null)
                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (u.Level > AdminLevel.Regular)
                        if (items.Contains(u.Id))
                            Callisto.SendPM(u, Callisto.Room.BotName, "\x000301IPSEND: " + str.Replace("+n", userobj.Name).Replace("+eip", userobj.ExternalIP.ToString()).Replace("+lip", userobj.LocalIP.ToString()).Replace("+p", userobj.Port.ToString()).Replace("+v", userobj.Version));
        }

        public static bool AddIPSend(IUser userobj)
        {
            if (items.Contains(userobj.Id))
                return false;

            items.Add(userobj.Id);
            String str = StringTemplate.GetString(STType.IPSend, 0);

            if (str != null)
                if (userobj.Level > AdminLevel.Regular)
                    for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                        Callisto.SendPM(userobj, Callisto.Room.BotName, "\x000301IPSEND: " + str.Replace("+n", u.Name).Replace("+eip", u.ExternalIP.ToString()).Replace("+lip", u.LocalIP.ToString()).Replace("+p", u.Port.ToString()).Replace("+v", u.Version));

            return true;
        }

        public static bool RemoveIPSend(IUser userobj)
        {
            if (!items.Contains(userobj.Id))
                return false;

            items.Remove(userobj.Id);
            return true;
        }
    }
}
