﻿using System;
using System.Collections.Generic;
using ICallisto;

namespace CallistoX
{
    class IdleManager
    {
        private static List<IdleItem> items = new List<IdleItem>();

        public static void Add(IUser userobj)
        {
            if (items.Find(x => x.guid == userobj.Guid && x.name == userobj.Name) != null)
                return;

            items.Add(new IdleItem
            {
                name = userobj.Name,
                guid = userobj.Guid,
                time = Helpers.UnixTimestamp()
            });

            if (StringTemplate.GetString(STType.Idling, 0) != null)
                Callisto.Print(StringTemplate.GetString(STType.Idling, 0).Replace("+n", userobj.Name).Replace("+t", Helpers.Time()));
        }

        public static void Remove(IUser userobj)
        {
            int i = items.FindIndex(x => x.guid == userobj.Guid && x.name == userobj.Name);

            if (i > -1)
            {
                TimeObj to = Helpers.GetIdleUptime(items[i].time);

                if (to.Days > 0)
                {
                    String str = StringTemplate.GetString(STType.Idling, 4);

                    if (str != null)
                        Callisto.Print(str.Replace("+n", userobj.Name).
                            Replace("+t", Helpers.Time()).
                            Replace("+d", to.Days.ToString()).
                            Replace("+h", to.Hours.ToString()).
                            Replace("+m", to.Minutes.ToString()).
                            Replace("+s", to.Seconds.ToString()), true);
                }
                else if (to.Hours > 0)
                {
                    String str = StringTemplate.GetString(STType.Idling, 3);

                    if (str != null)
                        Callisto.Print(str.Replace("+n", userobj.Name).
                            Replace("+t", Helpers.Time()).
                            Replace("+d", to.Days.ToString()).
                            Replace("+h", to.Hours.ToString()).
                            Replace("+m", to.Minutes.ToString()).
                            Replace("+s", to.Seconds.ToString()), true);
                }
                else if (to.Minutes > 0)
                {
                    String str = StringTemplate.GetString(STType.Idling, 2);

                    if (str != null)
                        Callisto.Print(str.Replace("+n", userobj.Name).
                            Replace("+t", Helpers.Time()).
                            Replace("+d", to.Days.ToString()).
                            Replace("+h", to.Hours.ToString()).
                            Replace("+m", to.Minutes.ToString()).
                            Replace("+s", to.Seconds.ToString()), true);
                }
                else
                {
                    String str = StringTemplate.GetString(STType.Idling, 1);

                    if (str != null)
                        Callisto.Print(str.Replace("+n", userobj.Name).
                            Replace("+t", Helpers.Time()).
                            Replace("+d", to.Days.ToString()).
                            Replace("+h", to.Hours.ToString()).
                            Replace("+m", to.Minutes.ToString()).
                            Replace("+s", to.Seconds.ToString()), true);
                }

                items.RemoveAt(i);
            }
        }
    }

    class IdleItem
    {
        public String name { get; set; }
        public String guid { get; set; }
        public uint time { get; set; }
    }
}
