﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ICallisto;

namespace CallistoX
{
    class Linking
    {
        public static void LinkHash(IUser userobj)
        {
            if (Callisto.Linker.IsLinked)
            {
                if (StringTemplate.GetString(STType.Linking, 0) != null)
                    Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 0).Replace("+r", Callisto.Linker.Name));

                if (StringTemplate.GetString(STType.Linking, 1) != null)
                    Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 1).Replace("+h", "\\\\arlnk://" + Callisto.Linker.Hashlink));
            }
            else if (StringTemplate.GetString(STType.Linking, 2) != null)
                Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 2));
        }

        public static void LinkInfo(IUser userobj)
        {
            if (Callisto.Linker.IsLinked)
            {
                for (IUser u = Callisto.FirstLinked; u != null; u = u.NextUser)
                    Callisto.Print(userobj, "\x000314--- " + u.Name + " [" + u.ExternalIP + "|" + u.LocalIP + "] " + u.Version);

                Callisto.Print(userobj, "");

                if (StringTemplate.GetString(STType.Linking, 0) != null)
                    Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 0).Replace("+r", Callisto.Linker.Name));

                if (StringTemplate.GetString(STType.Linking, 1) != null)
                    Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 1).Replace("+h", "\\\\arlnk://" + Callisto.Linker.Hashlink));
            }
            else if (StringTemplate.GetString(STType.Linking, 2) != null)
                Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 2));
        }

        public static void LinkConnect(IUser userobj, String args)
        {
            if (Callisto.Linker.IsLinked)
            {
                if (StringTemplate.GetString(STType.Linking, 3) != null)
                    Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 3).Replace("+r", Callisto.Linker.Name).Replace("+n", userobj.Name));
                return;
            }

            IChannelObject ch = Callisto.Hashlink.Decode(args);

            if (ch != null)
            {
                if (StringTemplate.GetString(STType.Linking, 4) != null)
                    Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 4).Replace("+r", ch.Name).Replace("+n", userobj.Name));

                Callisto.Linker.Connect(args);
            }
        }

        public static void LinkDisconnect(IUser userobj)
        {
            if (Callisto.Linker.IsLinked)
            {
                Callisto.Linker.Disconnect();

                if (StringTemplate.GetString(STType.Linking, 5) != null)
                    Callisto.Print(userobj, StringTemplate.GetLinkString(STType.Linking, 5).Replace("+n", userobj.Name));
            }
        }
    }
}
