﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Diagnostics;
using ICallisto;

namespace CallistoX
{
    class MotdManager
    {
        private static List<String> motd = new List<String>();

        public static void EditMOTD()
        {
            try
            {
                Process.Start("notepad.exe", Callisto.DataPath + "motd.txt");
            }
            catch { }
        }

        public static void Load(bool show)
        {
            try
            {
                if (!File.Exists(Callisto.DataPath + "motd.txt"))
                {
                    motd.Clear();
                    motd.Add("Welcome to my chatroom +n");
                    motd.Add("\x000303Have fun!");
                    File.WriteAllLines(Callisto.DataPath + "motd.txt", motd.ToArray(), Encoding.UTF8);
                }
                else
                {
                    motd = new List<String>(File.ReadAllLines(Callisto.DataPath + "motd.txt", Encoding.UTF8));

                    if (show)
                        if (StringTemplate.GetString(STType.AdminMessages, 13) != null)
                            Callisto.Print(StringTemplate.GetString(STType.AdminMessages, 13));
                }
            }
            catch { }

            for (int i = 0; i < motd.Count; i++)
                motd[i] = SetColors(motd[i]);
        }

        public static void View(IUser userobj)
        {
            if (motd.Count == 0)
                return;

            String rnd_user = Helpers.RandomUser(userobj).Name;
            String _str = Helpers.CountryCodeToString(userobj.Country);

            if (_str != "?")
                if (userobj.Region.Length > 0)
                    _str = userobj.Region + ", " + _str;

            if (_str == "?")
                if (userobj.Region.Length > 0)
                    _str = userobj.Region;

            if (_str == "?")
                _str = "unknown";

            foreach (String line in motd)
            {
                String str = line;
                str = str.Replace("+n", userobj.Name);
                str = str.Replace("+ip", userobj.ExternalIP.ToString());
                str = str.Replace("+id", userobj.Id.ToString());
                str = str.Replace("+f", userobj.FileCount.ToString());
                str = str.Replace("+v", userobj.Version);
                str = str.Replace("+p", userobj.Port.ToString());
                str = str.Replace("+uc", Callisto.Stats.CurrentUserCount.ToString());
                str = str.Replace("+rn", Callisto.Room.Name);
                str = str.Replace("+ut", Helpers.GetUptime(Callisto.Room.StartTime));
                str = str.Replace("+ru", rnd_user);
                str = str.Replace("+l", _str);
                Callisto.Print(userobj, str);
            }
        }

        private static String SetColors(String text)
        {
            String str = text;
            str = str.Replace("\x00025", "\x0005");
            str = str.Replace("\x00023", "\x0003");
            str = str.Replace("\x00026", "\x0006");
            str = str.Replace("\x00027", "\x0007");
            str = str.Replace("\x00029", "\x0009");
            return str;
        }
    }
}
