﻿using System;
using System.Windows.Forms;
using ICallisto;

namespace CallistoX
{
    partial class PluginEntryPoint
    {
        private IHost callback;
        private PluginGUI gui;

        public PluginEntryPoint()
        {
            this.gui = new PluginGUI();
            Callisto.RoomSearch = new RoomSearch();
        }

        public UserControl GUI
        {
            get { return this.gui; }
        }

        public IHost Host
        {
            get { return this.callback; }
            set
            {
                this.callback = value;
                Callisto.Set(this.callback);
            }
        }

        public void STT()
        {
            if (Callisto.Room.IsRunning)
            {
                WebResult[] results = WebResults.Results.Get();

                if (results.Length > 0)
                    foreach (WebResult r in results)
                        Callisto.Print(r.Vroom, r.Text, r.IncludeLink);
            }
        }

        public bool OnAvatarReceived(IUser userobj) { return true; }
        public bool OnPersonalReceived(IUser userobj, String msg) { return true; }
        public void OnBotPM(IUser userobj, String text) { }
    }
}
