﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using ICallisto;

namespace CallistoX
{
    class RangeBanManager
    {
        private static List<String> items = new List<String>();

        public static void AddBan(IUser admin, String ip)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;
            String q = ip.Replace("\"", "").Trim();

            if (!items.Contains(q))
            {
                if (StringTemplate.GetString(STType.AdminCommands, 18) != null)
                    Callisto.Print(StringTemplate.GetString(STType.AdminCommands, 18).Replace("+n", _admin).Replace("+t", q), true);

                AdminLog.AddLine(q + " range banned by " + admin.Name);
                items.Add(q);
                Save();
            }
        }

        public static void RemoveBan(IUser admin, int ident)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (ident < 0 || ident >= items.Count)
                return;

            if (StringTemplate.GetString(STType.AdminCommands, 19) != null)
                Callisto.Print(StringTemplate.GetString(STType.AdminCommands, 19).Replace("+n", _admin).Replace("+t", items[ident]), true);

            AdminLog.AddLine(items[ident] + " range unbanned by " + admin.Name);
            items.RemoveAt(ident);
            Save();
        }

        public static void RemoveBan(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (!args.StartsWith("\"") || !args.EndsWith("\""))
                return;

            String query = args.Replace("\"", "");
            int i = items.FindIndex(x => x == query);

            if (i > -1)
            {
                if (StringTemplate.GetString(STType.AdminCommands, 19) != null)
                    Callisto.Print(StringTemplate.GetString(STType.AdminCommands, 19).Replace("+n", _admin).Replace("+t", query), true);

                AdminLog.AddLine(query + " range unbanned by " + admin.Name);
                items.RemoveAt(i);
                Save();
            }
        }

        public static void ListBans(IUser asker)
        {
            if (items.Count == 0)
            {
                if (StringTemplate.GetString(STType.RangeBanList, 0) != null)
                    Callisto.Print(asker, StringTemplate.GetString(STType.RangeBanList, 0));
                return;
            }

            String str = StringTemplate.GetString(STType.RangeBanList, 1);

            if (str != null)
                for (int i = 0; i < items.Count; i++)
                    Callisto.Print(asker, str.Replace("+id", i.ToString()).Replace("+ip", items[i]));
        }

        public static bool IsBanned(IUser userobj)
        {
            return items.Find(x => userobj.ExternalIP.ToString().StartsWith(x) || userobj.LocalIP.ToString().StartsWith(x)) != null;
        }

        public static void Clear()
        {
            items.Clear();
            Save();
        }

        public static void Load()
        {
            try
            {
                FileStream f = new FileStream(Callisto.DataPath + "rangebans.xml", FileMode.Open);
                XmlReader xml = XmlReader.Create(new StreamReader(f));

                xml.MoveToContent();
                xml.ReadSubtree().ReadToFollowing("rangebans");

                while (xml.ReadToFollowing("item"))
                {
                    xml.ReadSubtree().ReadToFollowing("ip");
                    String ip = Encoding.UTF8.GetString(Convert.FromBase64String(xml.ReadElementContentAsString()));
                    items.Add(ip);
                }

                xml.Close();
                f.Flush();
                f.Close();
            }
            catch { }
        }

        private static void Save()
        {
            try
            {
                XmlWriterSettings appearance = new XmlWriterSettings();
                appearance.Indent = true;
                XmlWriter xml = XmlWriter.Create(Callisto.DataPath + "rangebans.xml", appearance);

                xml.WriteStartDocument();
                xml.WriteStartElement("rangebans");

                foreach (String a in items)
                {
                    xml.WriteStartElement("item");
                    xml.WriteElementString("ip", Convert.ToBase64String(Encoding.UTF8.GetBytes(a)));
                    xml.WriteEndElement();
                }

                xml.WriteEndElement();
                xml.WriteEndDocument();
                xml.Flush();
                xml.Close();
            }
            catch { }
        }
    }
}
