﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ICallisto;

namespace CallistoX
{
    class RoomInfo
    {
        private static int Tick = 0;

        private static String Hosts
        {
            get
            {
                List<String> list = new List<String>();

                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (u.Level == AdminLevel.Host)
                        list.Add(u.Name);

                return String.Join(", ", list.ToArray());
            }
        }

        private static String AdminCount
        {
            get
            {
                int count = 0;

                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (u.Level > AdminLevel.Regular)
                        count++;

                return count.ToString();
            }
        }

        public static void RoomInfoOn(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;

            if (args == "on" && !Settings.RoomInfoOn)
            {
                Settings.RoomInfoOn = true;
                Tick = 2000;
                Check();
                AdminLog.AddLine("room info enabled by " + admin.Name);
                String str = StringTemplate.GetString(STType.RoomInformation, 0);

                if (str != null)
                    Callisto.Print(str.Replace("+x", _admin), true);
            }
            else if (args == "off" && Settings.RoomInfoOn)
            {
                Settings.RoomInfoOn = false;
                AdminLog.AddLine("room info disabled by " + admin.Name);
                String str = StringTemplate.GetString(STType.RoomInformation, 1);

                if (str != null)
                    Callisto.Print(str.Replace("+x", _admin), true);
            }
        }

        public static void Status(IUser admin, String args)
        {
            String _admin = Settings.StealthOn ? Callisto.Room.BotName : admin.Name;
            Settings.HostStatus = args;
            AdminLog.AddLine("host status updated by " + admin.Name);

            if (!Settings.RoomInfoOn)
                Settings.RoomInfoOn = true;

            Tick = 2000;
            Check();

            String str = StringTemplate.GetString(STType.RoomInformation, 2);

            if (str != null)
                Callisto.Print(str.Replace("+x", _admin), true);
        }

        public static void Check()
        {
            if (Settings.RoomInfoOn)
            {
                if (Tick++ > 1200)
                {
                    Tick = 0;
                    String str;

                    str  = StringTemplate.GetString(STType.RoomInformation, 3);

                    if (str != null)
                    {
                        Callisto.Print(str);
                        Callisto.Print("");
                    }

                    str = StringTemplate.GetString(STType.RoomInformation, 4);

                    if (str != null)
                        Callisto.Print(str.Replace("+x", Hosts));

                    str = StringTemplate.GetString(STType.RoomInformation, 5);

                    if (str != null)
                        Callisto.Print(str.Replace("+x", Callisto.Stats.CurrentUserCount.ToString()));

                    str = StringTemplate.GetString(STType.RoomInformation, 6);

                    if (str != null)
                        Callisto.Print(str.Replace("+x", AdminCount));

                    str = StringTemplate.GetString(STType.RoomInformation, 7);

                    if (str != null)
                        Callisto.Print(str.Replace("+x", Helpers.GetUptime(Callisto.Room.StartTime)));

                    str = StringTemplate.GetString(STType.RoomInformation, 8);

                    if (str != null)
                        Callisto.Print(str.Replace("+x", Settings.HostStatus));

                    str = StringTemplate.GetString(STType.RoomInformation, 9);

                    if (str != null)
                        Callisto.Print(str);

                    str = StringTemplate.GetString(STType.RoomInformation, 10);

                    if (str != null)
                        Callisto.Print(str);

                    str = StringTemplate.GetString(STType.RoomInformation, 3);

                    if (str != null)
                    {
                        Callisto.Print("");
                        Callisto.Print(str);
                    }
                }
            }
        }

    }
}
