﻿using System;
using System.Text;
using System.IO;
using System.Xml;

namespace CallistoX
{
    class Settings
    {
        public static bool CanSave = true;
        private static int Tick = 0;

        private static bool general_on;
        private static bool caps_on;
        private static bool customnames_on;
        private static bool colors_on;
        private static bool last_seen;
        private static bool idle_on;
        private static bool chatlog_on;
        private static bool age_on;
        private static int age;
        private static bool cbans_on;
        private static int cbans_interval;
        private static uint cbans_last;
        private static bool allow_male;
        private static bool allow_female;
        private static bool allow_unknown;
        private static int muzzle_timeout;
        private static bool topic_clock;
        private static bool enable_admins;
        private static bool history_on;
        private static bool stealth_on;
        private static bool anon_on;
        private static bool share_on;
        private static bool greetmsg_on;
        private static bool pmgreetmsg_on;
        private static String pmgreetmsg;
        private static bool url_on;
        private static bool admin_announce_on;
        private static bool filters_on;
        private static String host_status;
        private static bool room_info;

        public static String HostStatus
        {
            get { return host_status; }
            set
            {
                host_status = value;
                Save();
            }
        }

        public static bool RoomInfoOn
        {
            get { return room_info; }
            set
            {
                room_info = value;
                Save();
            }
        }

        public static bool GeneralOn
        {
            get { return general_on; }
            set
            {
                general_on = value;
                Save();
            }
        }

        public static bool CapsOn
        {
            get { return caps_on; }
            set
            {
                caps_on = value;
                Save();
            }
        }

        public static bool CustomNamesOn
        {
            get { return customnames_on; }
            set
            {
                customnames_on = value;
                Save();
            }
        }

        public static bool ColorsOn
        {
            get { return colors_on; }
            set
            {
                colors_on = value;
                Save();
            }
        }

        public static bool LastSeenOn
        {
            get { return last_seen; }
            set
            {
                last_seen = value;
                Save();
            }
        }

        public static bool IdleOn
        {
            get { return idle_on; }
            set
            {
                idle_on = value;
                Save();
            }
        }

        public static bool ChatLogOn
        {
            get { return chatlog_on; }
            set
            {
                chatlog_on = value;
                Save();
            }
        }

        public static bool AgeOn
        {
            get { return age_on; }
            set
            {
                age_on = value;
                Save();
            }
        }

        public static int Age
        {
            get { return age; }
            set { age = value; }
        }

        public static bool CbansOn
        {
            get { return cbans_on; }
            set
            {
                cbans_on = value;
                Save();
            }
        }

        public static int CbansInterval
        {
            get { return cbans_interval; }
            set { cbans_interval = value; }
        }

        public static uint CbansLast
        {
            get { return cbans_last; }
            set
            {
                cbans_last = value;
                Save();
            }
        }

        public static bool AllowMale
        {
            get { return allow_male; }
            set
            {
                allow_male = value;
                Save();
            }
        }

        public static bool AllowFemale
        {
            get { return allow_female; }
            set
            {
                allow_female = value;
                Save();
            }
        }

        public static bool AllowUnknown
        {
            get { return allow_unknown; }
            set
            {
                allow_unknown = value;
                Save();
            }
        }

        public static int MuzzleTimeout
        {
            get { return muzzle_timeout; }
            set
            {
                muzzle_timeout = value;
                Save();
            }
        }

        public static bool TopicClock
        {
            get { return topic_clock; }
            set
            {
                topic_clock = value;
                Save();
            }
        }

        public static bool EnableAdmins
        {
            get { return enable_admins; }
            set
            {
                enable_admins = value;
                Save();
            }
        }

        public static bool HistoryOn
        {
            get { return history_on; }
            set
            {
                history_on = value;
                Save();
            }
        }

        public static bool StealthOn
        {
            get { return stealth_on; }
            set
            {
                stealth_on = value;
                Save();
            }
        }

        public static bool AnonOn
        {
            get { return anon_on; }
            set
            {
                anon_on = value;
                Save();
            }
        }

        public static bool ShareOn
        {
            get { return share_on; }
            set
            {
                share_on = value;
                Save();
            }
        }

        public static bool GreetMsgOn
        {
            get { return greetmsg_on; }
            set
            {
                greetmsg_on = value;
                Save();
            }
        }

        public static bool PMGreetMsgOn
        {
            get { return pmgreetmsg_on; }
            set
            {
                pmgreetmsg_on = value;
                Save();
            }
        }

        public static String PMGreetMsg
        {
            get { return pmgreetmsg; }
            set
            {
                pmgreetmsg = value;
                Save();
            }
        }

        public static bool UrlOn
        {
            get { return url_on; }
            set
            {
                url_on = value;
                Save();
            }
        }

        public static bool AdminAnnounceOn
        {
            get { return admin_announce_on; }
            set
            {
                admin_announce_on = value;
                Save();
            }
        }

        public static bool FiltersOn
        {
            get { return filters_on; }
            set
            {
                filters_on = value;
                Save();
            }
        }

        public static void Load()
        {
            general_on = true;
            caps_on = false;
            customnames_on = true;
            colors_on = true;
            last_seen = false;
            idle_on = false;
            chatlog_on = true;
            age_on = false;
            age = 18;
            cbans_on = false;
            cbans_interval = 12;
            cbans_last = Helpers.UnixTimestamp();
            allow_male = true;
            allow_female = true;
            allow_unknown = true;
            muzzle_timeout = 0;
            topic_clock = false;
            enable_admins = true;
            history_on = false;
            stealth_on = false;
            anon_on = false;
            share_on = false;
            greetmsg_on = false;
            pmgreetmsg_on = false;
            pmgreetmsg = String.Empty;
            url_on = false;
            admin_announce_on = true;
            filters_on = false;
            host_status = "hello world";
            room_info = false;

            try
            {
                FileStream f = new FileStream(Callisto.DataPath + "settings.xml", FileMode.Open);

                try
                {
                    XmlReader xml = XmlReader.Create(new StreamReader(f));

                    xml.MoveToContent();
                    xml.ReadSubtree().ReadToFollowing("callistox");
                    xml.ReadToFollowing("settings");
                    xml.ReadSubtree().ReadToFollowing("general_on");
                    general_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("caps_on");
                    caps_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("customnames_on");
                    customnames_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("colors_on");
                    colors_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("last_seen");
                    last_seen = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("idle_on");
                    idle_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("chatlog_on");
                    chatlog_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("age_on");
                    age_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("age");
                    age = int.Parse(xml.ReadElementContentAsString());

                    if (age > 50 || age < 15)
                        age = 18;

                    xml.ReadToFollowing("cbans_on");
                    cbans_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("cbans_interval");
                    cbans_interval = int.Parse(xml.ReadElementContentAsString());

                    if (cbans_interval > 72 || cbans_interval < 1)
                        cbans_interval = 12;

                    xml.ReadToFollowing("cbans_last");
                    cbans_last = uint.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("allow_male");
                    allow_male = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("allow_female");
                    allow_female = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("allow_unknown");
                    allow_unknown = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("muzzle_timeout");
                    muzzle_timeout = int.Parse(xml.ReadElementContentAsString());

                    if (muzzle_timeout > 90 || muzzle_timeout < 0)
                        muzzle_timeout = 0;

                    xml.ReadToFollowing("topic_clock");
                    topic_clock = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("enable_admins");
                    enable_admins = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("history_on");
                    history_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("stealth_on");
                    stealth_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("anon_on");
                    anon_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("share_on");
                    share_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("greetmsg_on");
                    greetmsg_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("pmgreetmsg_on");
                    pmgreetmsg_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("pmgreetmsg");
                    pmgreetmsg = Encoding.UTF8.GetString(Convert.FromBase64String(xml.ReadElementContentAsString()));
                    xml.ReadToFollowing("url_on");
                    url_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("admin_announce_on");
                    admin_announce_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("filters_on");
                    filters_on = bool.Parse(xml.ReadElementContentAsString());
                    xml.ReadToFollowing("host_status");
                    host_status = Encoding.UTF8.GetString(Convert.FromBase64String(xml.ReadElementContentAsString()));
                    xml.ReadToFollowing("room_info");
                    room_info = bool.Parse(xml.ReadElementContentAsString());

                    xml.Close();
                }
                catch { }

                f.Flush();
                f.Close();
            }
            catch { }
        }

        public static void Update(bool force)
        {
            if (force)
            {
                Save();
                return;
            }

            if (Tick++ > 60)
            {
                Tick = 0;
                Save();
            }
        }

        private static void Save()
        {
            if (!CanSave)
                return;

            try
            {
                XmlWriterSettings appearance = new XmlWriterSettings();
                appearance.Indent = true;
                XmlWriter xml = XmlWriter.Create(Callisto.DataPath + "settings.xml", appearance);

                xml.WriteStartDocument();
                xml.WriteStartElement("callistox");
                xml.WriteStartElement("settings");
                xml.WriteElementString("general_on", general_on.ToString().ToLower());
                xml.WriteElementString("caps_on", caps_on.ToString().ToLower());
                xml.WriteElementString("customnames_on", customnames_on.ToString().ToLower());
                xml.WriteElementString("colors_on", colors_on.ToString().ToLower());
                xml.WriteElementString("last_seen", last_seen.ToString().ToLower());
                xml.WriteElementString("idle_on", idle_on.ToString().ToLower());
                xml.WriteElementString("chatlog_on", chatlog_on.ToString().ToLower());
                xml.WriteElementString("age_on", age_on.ToString().ToLower());
                xml.WriteElementString("age", age.ToString());
                xml.WriteElementString("cbans_on", cbans_on.ToString().ToLower());
                xml.WriteElementString("cbans_interval", cbans_interval.ToString());
                xml.WriteElementString("cbans_last", cbans_last.ToString());
                xml.WriteElementString("allow_male", allow_male.ToString().ToLower());
                xml.WriteElementString("allow_female", allow_female.ToString().ToLower());
                xml.WriteElementString("allow_unknown", allow_unknown.ToString().ToLower());
                xml.WriteElementString("muzzle_timeout", muzzle_timeout.ToString());
                xml.WriteElementString("topic_clock", topic_clock.ToString().ToLower());
                xml.WriteElementString("enable_admins", enable_admins.ToString().ToLower());
                xml.WriteElementString("history_on", history_on.ToString().ToLower());
                xml.WriteElementString("stealth_on", stealth_on.ToString().ToLower());
                xml.WriteElementString("anon_on", anon_on.ToString().ToLower());
                xml.WriteElementString("share_on", share_on.ToString().ToLower());
                xml.WriteElementString("greetmsg_on", greetmsg_on.ToString().ToLower());
                xml.WriteElementString("pmgreetmsg_on", pmgreetmsg_on.ToString().ToLower());
                xml.WriteElementString("pmgreetmsg", Convert.ToBase64String(Encoding.UTF8.GetBytes(pmgreetmsg)));
                xml.WriteElementString("url_on", url_on.ToString().ToLower());
                xml.WriteElementString("admin_announce_on", admin_announce_on.ToString().ToLower());
                xml.WriteElementString("filters_on", filters_on.ToString().ToLower());
                xml.WriteElementString("host_status", Convert.ToBase64String(Encoding.UTF8.GetBytes(host_status)));
                xml.WriteElementString("room_info", room_info.ToString().ToLower());
                xml.WriteEndElement();
                xml.WriteEndElement();
                xml.WriteEndDocument();
                xml.Flush();
                xml.Close();
            }
            catch { }
        }
    }
}
