﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace CallistoX
{
    class StringTemplate
    {
        private static List<STObj> items;

        public static void Load(bool load_default_only)
        {
            items = new List<STObj>();

            // admin list
            items.Add(new STObj { Type = STType.AdminList, Index = 0, Text = "ADMIN LIST [+n]" });
            items.Add(new STObj { Type = STType.AdminList, Index = 1, Text = "[Level +l] +n" });
            items.Add(new STObj { Type = STType.AdminList, Index = 2, Text = "LIST COMPLETE" });

            // enable/disable
            items.Add(new STObj { Type = STType.EnableDisable, Index = 0, Text = "topic clock has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 1, Text = "topic clock has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 2, Text = "admin announce filters have been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 3, Text = "admin announce filters have been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 4, Text = "filter system has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 5, Text = "filter system has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 6, Text = "chat history has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 7, Text = "chat history has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 8, Text = "general commands have been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 9, Text = "general commands have been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 10, Text = "CAPS monitoring has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 11, Text = "CAPS monitoring has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 12, Text = "color text has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 13, Text = "color text has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 14, Text = "last seen monitoring has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 15, Text = "last seen monitoring has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 16, Text = "custom names have been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 17, Text = "custom names have been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 18, Text = "idle monitoring has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 19, Text = "idle monitoring has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 20, Text = "share files monitoring has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 21, Text = "share files monitoring has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 22, Text = "anon monitoring has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 23, Text = "anon monitoring has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 24, Text = "stealth mode has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 25, Text = "stealth mode has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 26, Text = "room commands enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 27, Text = "room commands disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 28, Text = "pm greet message has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 29, Text = "pm greet message has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 30, Text = "greet message has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 31, Text = "greet message has been disabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 32, Text = "url tag has been enabled by +n" });
            items.Add(new STObj { Type = STType.EnableDisable, Index = 33, Text = "utl tag has been disabled by +n" });

            // admin messages
            items.Add(new STObj { Type = STType.AdminMessages, Index = 0, Text = "+n has been added to ip send" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 1, Text = "+n has been removed from ip send" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 2, Text = "+n has been added to ban send" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 3, Text = "+n has been removed from ban send" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 4, Text = "+n> [shout] +x" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 5, Text = "Whisper (+n to +t): +x" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 6, Text = "+n cloned +t" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 7, Text = "+n announced" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 8, Text = "+n has moved +t to +x" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 9, Text = "+n has changed +t's name to +x" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 10, Text = "+n restored +t's name" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 11, Text = "+n has been added to log send" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 12, Text = "+n has been removed from log send" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 13, Text = "MOTD has been reloaded" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 14, Text = "commands are disabled" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 15, Text = "you have flooded" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 16, Text = "+n has flooded [+x]" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 17, Text = "String Template has been updated" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 18, Text = "+n has been added to vspy" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 19, Text = "+n has been removed from vspy" });
            items.Add(new STObj { Type = STType.AdminMessages, Index = 20, Text = "+n> [admin] +x" });

            // admin commands
            items.Add(new STObj { Type = STType.AdminCommands, Index = 0, Text = "+n has cleared all the ban lists" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 1, Text = "+n has redirected +t to +x" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 2, Text = "all ban lists have been automatically cleared" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 3, Text = "+t was killed by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 4, Text = "+t was banned by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 5, Text = "+t was unbanned by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 6, Text = "+n has set +t's custom name" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 7, Text = "+n has unset +t's custom name" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 8, Text = "+t has been echoed by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 9, Text = "+t has been unechoed by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 10, Text = "+t has been kiddied by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 11, Text = "+t has been unkiddied by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 12, Text = "+t has been lowered by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 13, Text = "+t has been unlowered by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 14, Text = "+t has been muzzled by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 15, Text = "+t has been unmuzzled by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 16, Text = "+t has been painted by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 17, Text = "+t has been unpainted by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 18, Text = "+t has been range banned by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 19, Text = "+t has been range unbanned by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 20, Text = "+n has updated the main room topic" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 21, Text = "+n has updated vroom +x's topic" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 22, Text = "+t has been translated to +x by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 23, Text = "+t has been untranslated by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 24, Text = "screen cleared by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 25, Text = "+t's avatar was disabled by +n" });
            items.Add(new STObj { Type = STType.AdminCommands, Index = 26, Text = "+t's avatar was enabled by +n" });

            // admin login
            items.Add(new STObj { Type = STType.AdminLogin, Index = 0, Text = "+n has been banned for too many invalid logins" });
            items.Add(new STObj { Type = STType.AdminLogin, Index = 1, Text = "invalid login attempt from +n" });
            items.Add(new STObj { Type = STType.AdminLogin, Index = 2, Text = "+n has temporarily set +t's level to +x" });
            items.Add(new STObj { Type = STType.AdminLogin, Index = 3, Text = "+n has unset +t's admin level" });
            items.Add(new STObj { Type = STType.AdminLogin, Index = 4, Text = "+n has added +t to auto login" });
            items.Add(new STObj { Type = STType.AdminLogin, Index = 5, Text = "+n has removed +t from auto login" });
            items.Add(new STObj { Type = STType.AdminLogin, Index = 6, Text = "+n has logged in as level +x" });

            // ban send
            items.Add(new STObj { Type = STType.BanSend, Index = 0, Text = "+n [+ip] is too young" });
            items.Add(new STObj { Type = STType.BanSend, Index = 1, Text = "+n [+ip] is banned" });
            items.Add(new STObj { Type = STType.BanSend, Index = 2, Text = "+n [+ip] is wrong gender" });
            items.Add(new STObj { Type = STType.BanSend, Index = 3, Text = "+n [+ip] is range banned" });
            items.Add(new STObj { Type = STType.BanSend, Index = 4, Text = "+n [+ip] is an anon" });
            items.Add(new STObj { Type = STType.BanSend, Index = 5, Text = "+n [+ip] is not sharing files" });
            items.Add(new STObj { Type = STType.BanSend, Index = 6, Text = "+n [+ip] exceeded maximum clients per ip address" });
            items.Add(new STObj { Type = STType.BanSend, Index = 7, Text = "+n [+ip] attempted to rejoin too quickly" });
            items.Add(new STObj { Type = STType.BanSend, Index = 8, Text = "+n [+ip] name already in use" });
            items.Add(new STObj { Type = STType.BanSend, Index = 9, Text = "+n [+ip] was blocked by the join filter" });

            // filter messages
            items.Add(new STObj { Type = STType.FilterMessages, Index = 0, Text = "+n was killed for sharing +x" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 1, Text = "+n was banned for sharing +x" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 2, Text = "+n was kiddied for typing a filtered word" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 3, Text = "+n was muzzled for typing a filtered word" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 4, Text = "+n was killed for typing a filtered word in pm" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 5, Text = "+n was banned for typing a filtered word in pm" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 6, Text = "+n your pm was blocked for typing a filtered word" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 7, Text = "+n was killed for typing a filtered word" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 8, Text = "+n was banned for typing a filtered word" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 9, Text = "+n was moved to vroom +x for typing a filtered word" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 10, Text = "+n your text was censored for typing a filtered word" });
            items.Add(new STObj { Type = STType.FilterMessages, Index = 11, Text = "+n was redirected to +x for typing a filtered word" });

            // filter content
            items.Add(new STObj { Type = STType.FilterContent, Index = 0, Text = "file filter added by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 1, Text = "file filter removed by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 2, Text = "join filter added by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 3, Text = "join filter removed by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 4, Text = "pm filter added by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 5, Text = "pm filter removed by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 6, Text = "word filter added by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 7, Text = "word filter removed by +n [trigger: +t | type: +x]" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 8, Text = "line added in +t by +n" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 9, Text = "line edited in +t by +n" });
            items.Add(new STObj { Type = STType.FilterContent, Index = 10, Text = "line removed in +t by +n" });

            // greets
            items.Add(new STObj { Type = STType.Greetings, Index = 0, Text = "a greet message has been added by +n" });
            items.Add(new STObj { Type = STType.Greetings, Index = 1, Text = "a greet message has been removed by +n" });
            items.Add(new STObj { Type = STType.Greetings, Index = 2, Text = "pm greet message has been set by +n" });

            // chat history
            items.Add(new STObj { Type = STType.ChatHistory, Index = 0, Text = "chat history ends" });

            // idle monitor
            items.Add(new STObj { Type = STType.Idling, Index = 0, Text = "+n idles at +t" });
            items.Add(new STObj { Type = STType.Idling, Index = 1, Text = "+n returns at +t after +s seconds" });
            items.Add(new STObj { Type = STType.Idling, Index = 2, Text = "+n returns at +t after +m minutes +s seconds" });
            items.Add(new STObj { Type = STType.Idling, Index = 3, Text = "+n returns at +t after +h hours +m minutes +s seconds" });
            items.Add(new STObj { Type = STType.Idling, Index = 4, Text = "+n returns at +t after +d days +h hours +m minutes +s seconds" });

            // linking
            items.Add(new STObj { Type = STType.Linking, Index = 0, Text = "Room: +r" });
            items.Add(new STObj { Type = STType.Linking, Index = 1, Text = "Hashlink: +h" });
            items.Add(new STObj { Type = STType.Linking, Index = 2, Text = "There is no link session currently active" });
            items.Add(new STObj { Type = STType.Linking, Index = 3, Text = "Already linked to +r!!" });
            items.Add(new STObj { Type = STType.Linking, Index = 4, Text = "Linking to +r, please wait..." });
            items.Add(new STObj { Type = STType.Linking, Index = 5, Text = "Link session terminated by +n" });
            items.Add(new STObj { Type = STType.Linking, Index = 6, Text = "Link established with +r (Y)" });
            items.Add(new STObj { Type = STType.Linking, Index = 7, Text = "Link session with +r has ended" });
            items.Add(new STObj { Type = STType.Linking, Index = 8, Text = "The linked room has admin sharing disabled" });
            items.Add(new STObj { Type = STType.Linking, Index = 9, Text = "Link Error: +n" });

            // muzzle messages
            items.Add(new STObj { Type = STType.MuzzleMessages, Index = 0, Text = "muzzle timeout set to +t minutes by +n" });
            items.Add(new STObj { Type = STType.MuzzleMessages, Index = 1, Text = "muzzle timeout disabled by +n" });
            items.Add(new STObj { Type = STType.MuzzleMessages, Index = 2, Text = "+n's muzzle timeout has expired" });
            items.Add(new STObj { Type = STType.MuzzleMessages, Index = 3, Text = "[muzzled] +n> +t" });
            items.Add(new STObj { Type = STType.MuzzleMessages, Index = 4, Text = "[muzzled] * +n +t" });
            items.Add(new STObj { Type = STType.MuzzleMessages, Index = 5, Text = "You are muzzled" });

            // rejection messages
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 0, Text = "you are banned from this chatroom" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 1, Text = "you have exceeded the maximum number of clients from this ip address" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 2, Text = "please wait a minute and try again" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 3, Text = "please select an alternative user name" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 4, Text = "you are too young for this chatroom" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 5, Text = "please choose a name in control panel and then rejoin" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 6, Text = "your gender is not allowed in this chatroom" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 7, Text = "you are range banned from this chatroom" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 8, Text = "please share some files and then rejoin" });
            items.Add(new STObj { Type = STType.RejectionMessages, Index = 9, Text = "you have been blocked by the join filter" });

            // pm blocking
            items.Add(new STObj { Type = STType.PMBlocking, Index = 0, Text = "+n has been added to pm blocking" });
            items.Add(new STObj { Type = STType.PMBlocking, Index = 1, Text = "+n has been removed from pm blocking" });
            items.Add(new STObj { Type = STType.PMBlocking, Index = 2, Text = "+n was unable to receive this message as their pm is blocked" });

            // url links
            items.Add(new STObj { Type = STType.URL, Index = 0, Text = "a url tag has been added by +n" });
            items.Add(new STObj { Type = STType.URL, Index = 1, Text = "a url tag has been removed by +n" });

            // vrooms
            items.Add(new STObj { Type = STType.Vrooms, Index = 0, Text = "+n -> +v" });
            items.Add(new STObj { Type = STType.Vrooms, Index = 1, Text = "+n -> +v [locked]" });
            items.Add(new STObj { Type = STType.Vrooms, Index = 2, Text = "+n has locked vroom +v" });
            items.Add(new STObj { Type = STType.Vrooms, Index = 3, Text = "+n has unlocked vroom +v" });
            items.Add(new STObj { Type = STType.Vrooms, Index = 4, Text = "+n you can't join vroom +v because it is locked!" });

            // whowas
            items.Add(new STObj { Type = STType.Whowas, Index = 0, Text = "no results were found containing +q" });
            items.Add(new STObj { Type = STType.Whowas, Index = 1, Text = "result: +n +e +v +t" });

            // last seen
            items.Add(new STObj { Type = STType.LastSeen, Index = 0, Text = "+n was last seen as +x from +ip" });

            // trace
            items.Add(new STObj { Type = STType.Trace, Index = 0, Text = "wait a few seconds and then try again" });
            items.Add(new STObj { Type = STType.Trace, Index = 1, Text = "unable to trace a result for +x" });
            items.Add(new STObj { Type = STType.Trace, Index = 2, Text = "trace results for +x" });
            items.Add(new STObj { Type = STType.Trace, Index = 3, Text = "country: +x" });
            items.Add(new STObj { Type = STType.Trace, Index = 4, Text = "region: +x" });
            items.Add(new STObj { Type = STType.Trace, Index = 5, Text = "city: +x" });
            items.Add(new STObj { Type = STType.Trace, Index = 6, Text = "local time: +x" });
            items.Add(new STObj { Type = STType.Trace, Index = 7, Text = "trace complete" });

            // urban dictinoary
            items.Add(new STObj { Type = STType.UrbanDictionary, Index = 0, Text = "wait a few seconds and then try again" });
            items.Add(new STObj { Type = STType.UrbanDictionary, Index = 1, Text = "unable to find an urban definition for +x" });
            items.Add(new STObj { Type = STType.UrbanDictionary, Index = 2, Text = "urban definition for +x" });
            items.Add(new STObj { Type = STType.UrbanDictionary, Index = 3, Text = "+x" });
            items.Add(new STObj { Type = STType.UrbanDictionary, Index = 4, Text = "urban example for +x" });
            items.Add(new STObj { Type = STType.UrbanDictionary, Index = 5, Text = "+x" });

            // dictionary definition
            items.Add(new STObj { Type = STType.DictionaryDefine, Index = 0, Text = "wait a few seconds and then try again" });
            items.Add(new STObj { Type = STType.DictionaryDefine, Index = 1, Text = "unable to find an dictionary definition for +x" });
            items.Add(new STObj { Type = STType.DictionaryDefine, Index = 2, Text = "dictionary definition for +x" });
            items.Add(new STObj { Type = STType.DictionaryDefine, Index = 3, Text = "+x" });
            items.Add(new STObj { Type = STType.DictionaryDefine, Index = 4, Text = "+x" });

            // room search +n +t +l +s +u +h +x
            items.Add(new STObj { Type = STType.Roomsearch, Index = 0, Text = "unable to find any results containing +x" });
            items.Add(new STObj { Type = STType.Roomsearch, Index = 1, Text = "results for +x as follows:" });
            items.Add(new STObj { Type = STType.Roomsearch, Index = 2, Text = "name: +n" });
            items.Add(new STObj { Type = STType.Roomsearch, Index = 3, Text = "topic: +t" });
            items.Add(new STObj { Type = STType.Roomsearch, Index = 4, Text = "language: +l" });
            items.Add(new STObj { Type = STType.Roomsearch, Index = 5, Text = "server: +s" });
            items.Add(new STObj { Type = STType.Roomsearch, Index = 6, Text = "user count: +u" });
            items.Add(new STObj { Type = STType.Roomsearch, Index = 7, Text = "hashlink: +h" });

            // ban stats
            items.Add(new STObj { Type = STType.BanStats, Index = 0, Text = "+n [+ip] banned for sharing a filtered file" });
            items.Add(new STObj { Type = STType.BanStats, Index = 1, Text = "+n [+ip] banned for triggering a join filter" });
            items.Add(new STObj { Type = STType.BanStats, Index = 2, Text = "+n [+ip] banned for being an unauthorised age" });
            items.Add(new STObj { Type = STType.BanStats, Index = 3, Text = "+n [+ip] banned for typing a filtered word in pm" });
            items.Add(new STObj { Type = STType.BanStats, Index = 4, Text = "+n [+ip] banned for invalid login attempts" });
            items.Add(new STObj { Type = STType.BanStats, Index = 5, Text = "+n [+ip] banned for typing a filtered word" });
            items.Add(new STObj { Type = STType.BanStats, Index = 6, Text = "+n [+ip] banned for being an unauthorised gender" });
            items.Add(new STObj { Type = STType.BanStats, Index = 7, Text = "+n [+ip] banned by +x" });

            // clock topic
            items.Add(new STObj { Type = STType.ClockTopic, Index = 0, Text = "[+c] +t [+c]" });

            // cloak
            items.Add(new STObj { Type = STType.Cloak, Index = 0, Text = "+n has enabled cloaking" });
            items.Add(new STObj { Type = STType.Cloak, Index = 1, Text = "+n has disabled cloaking" });

            // room information
            items.Add(new STObj { Type = STType.RoomInformation, Index = 0, Text = "room information enabled by +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 1, Text = "room information disabled by +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 2, Text = "host status updated by +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 3, Text = "room information" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 4, Text = "hosts: +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 5, Text = "user count: +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 6, Text = "admin count: +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 7, Text = "server uptime: +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 8, Text = "host status: +x" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 9, Text = "" });
            items.Add(new STObj { Type = STType.RoomInformation, Index = 10, Text = "" });

            // stats
            items.Add(new STObj { Type = STType.Stats, Index = 0, Text = "Stats for +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 1, Text = "Language: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 2, Text = "Hashlink: arlnk://+x" });
            items.Add(new STObj { Type = STType.Stats, Index = 3, Text = "Uptime: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 4, Text = "Bytes received: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 5, Text = "Bytes sent: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 6, Text = "Invalid logins: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 7, Text = "Flooded users: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 8, Text = "Rejected users: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 9, Text = "Join count: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 10, Text = "Part count: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 11, Text = "User count: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 12, Text = "Peak count: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 13, Text = "Message count: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 14, Text = "PM count: +x" });
            items.Add(new STObj { Type = STType.Stats, Index = 15, Text = "Roomsearch size: +x" });

            // whois
            items.Add(new STObj { Type = STType.Whois, Index = 0, Text = "Name: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 1, Text = "Originally: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 2, Text = "External IP: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 3, Text = "Local IP: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 4, Text = "Data Port: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 5, Text = "Version: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 6, Text = "Vroom: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 7, Text = "ID: +x" });
            items.Add(new STObj { Type = STType.Whois, Index = 8, Text = "Linked: +x" });

            // info
            items.Add(new STObj { Type = STType.Info, Index = 0, Text = "+id - +n -> +v" });

            // filter list
            items.Add(new STObj { Type = STType.FilterList, Index = 0, Text = "there are no filters currently set" });
            items.Add(new STObj { Type = STType.FilterList, Index = 1, Text = "+id - +t [+x]" });

            // ban list
            items.Add(new STObj { Type = STType.BanList, Index = 0, Text = "there are no bans currently set" });
            items.Add(new STObj { Type = STType.BanList, Index = 1, Text = "+id - +n [+ip]" });

            // range ban list
            items.Add(new STObj { Type = STType.RangeBanList, Index = 0, Text = "there are no range bans currently set" });
            items.Add(new STObj { Type = STType.RangeBanList, Index = 1, Text = "+id - +ip" });

            // IP Send
            items.Add(new STObj { Type = STType.IPSend, Index = 0, Text = "+n | +eip | +lip | +p | +v" });

            // VSpy
            items.Add(new STObj { Type = STType.VSpy, Index = 0, Text = "[+v] +n [+ip] sharing +f files, has joined" });
            items.Add(new STObj { Type = STType.VSpy, Index = 1, Text = "[+v] +n [+ip] has parted" });
            items.Add(new STObj { Type = STType.VSpy, Index = 2, Text = "[+v] +n> +t" });
            items.Add(new STObj { Type = STType.VSpy, Index = 3, Text = "[+v] * +n +t" });

            // Captcha
            items.Add(new STObj { Type = STType.Captcha, Index = 0, Text = "Too many incorrect answers" });
            items.Add(new STObj { Type = STType.Captcha, Index = 1, Text = "Incorrect answer.  Please solve this math puzzle to allow you to chat" });
            items.Add(new STObj { Type = STType.Captcha, Index = 2, Text = "Please solve this math puzzle to allow you to chat" });
            items.Add(new STObj { Type = STType.Captcha, Index = 3, Text = "Correct answer.  You may now chat" });


            if (!load_default_only)
                LoadXML();
        }

        public static String GetString(STType t, int i)
        {
            STObj o = items.Find(x => x.Type == t && x.Index == i);

            if (o != null)
                if (o.Text.Length > 0)
                    return FormatColors(o.Text);

            return null;
        }

        public static String GetLinkString(STType t, int i)
        {
            STObj o = items.Find(x => x.Type == t && x.Index == i);

            if (o != null)
                if (o.Text.Length > 0)
                    return "\x000314--- " + FormatColors(o.Text);

            return null;
        }

        private static String FormatColors(String str)
        {
            String s = str;
            s = s.Replace("\x00023", "\x0003");
            s = s.Replace("\x00025", "\x0005");
            s = s.Replace("\x00026", "\x0006");
            s = s.Replace("\x00027", "\x0007");
            s = s.Replace("\x00029", "\x0009");
            s = s.Replace("\x0002", String.Empty);
            return s;
        }

        public static void Populate(DataGridView grid)
        {
            int row = 0;
            grid.Rows.Clear();

            for (int i = 0; i < Enum.GetNames(typeof(STType)).Length; i++)
            {
                grid.Rows.Add(items.FindAll(x => x.Type == (STType)i).Count() + 1);
                grid.Rows[row].Cells[0].Value = SectionTitle((STType)i);
                grid.Rows[row].Tag = null;
                grid.Rows[row].Cells[0].Style.BackColor = Color.Gainsboro;
                grid.Rows[row].Cells[0].Style.ForeColor = Color.Maroon;
                grid.Rows[row].ReadOnly = true;
                row++;

                foreach (STObj o in items.FindAll(x => x.Type == (STType)i))
                {
                    grid.Rows[row].Cells[0].Value = o.Text;
                    grid.Rows[row++].Cells[0].Tag = new STCell
                    {
                        Index = o.Index,
                        Type = o.Type
                    };
                }
            }
        }

        private static void LoadXML()
        {
            try
            {
                FileStream f = new FileStream(Callisto.DataPath + "strings.xml", FileMode.Open);
                XmlReader xml = XmlReader.Create(new StreamReader(f));

                xml.MoveToContent();
                xml.ReadSubtree().ReadToFollowing("strings");

                while (xml.ReadToFollowing("item"))
                {
                    xml.ReadSubtree().ReadToFollowing("type");
                    STType type = (STType)Enum.Parse(typeof(STType), xml.ReadElementContentAsString());

                    xml.ReadToFollowing("index");
                    int index = int.Parse(xml.ReadElementContentAsString());

                    xml.ReadToFollowing("value");
                    String value = Encoding.UTF8.GetString(Convert.FromBase64String(xml.ReadElementContentAsString()));

                    items.FindAll(x => x.Index == index && x.Type == type).ForEach(x => x.Text = value);
                }

                xml.Close();
                f.Flush();
                f.Close();
            }
            catch { }
        }

        public static void SaveAndUpdate(DataGridView grid)
        {
            for (int i = 0; i < grid.Rows.Count; i++)
            {
                if (grid.Rows[i].Cells[0].Tag != null)
                {
                    STCell o = (STCell)grid.Rows[i].Cells[0].Tag;
                    items.FindAll(x => x.Index == o.Index && x.Type == o.Type).ForEach(x => x.Text = (String)grid.Rows[i].Cells[0].Value);
                }
            }

            try
            {
                XmlWriterSettings appearance = new XmlWriterSettings();
                appearance.Indent = true;
                XmlWriter xml = XmlWriter.Create(Callisto.DataPath + "strings.xml", appearance);

                xml.WriteStartDocument();
                xml.WriteStartElement("strings");

                foreach (STObj a in items)
                {
                    xml.WriteStartElement("item");
                    xml.WriteElementString("type", a.Type.ToString());
                    xml.WriteElementString("index", a.Index.ToString());
                    xml.WriteElementString("value", Convert.ToBase64String(Encoding.UTF8.GetBytes(a.Text)));
                    xml.WriteEndElement();
                }

                xml.WriteEndElement();
                xml.WriteEndDocument();
                xml.Flush();
                xml.Close();

                if (GetString(STType.AdminMessages, 17) != null)
                    Callisto.Print(GetString(STType.AdminMessages, 17));
            }
            catch { }
        }

        public static String SectionTitle(STType o)
        {
            switch (o)
            {
                case STType.AdminList:
                    return "Admin List [+n +l]";

                case STType.EnableDisable:
                    return "Enable/Disable [+n]";

                case STType.AdminMessages:
                    return "Admin Messages [+n +t +x]";

                case STType.AdminCommands:
                    return "Admin Commands [+n +t +x]";

                case STType.AdminLogin:
                    return "Admin Logins [+n +t +x]";

                case STType.BanSend:
                    return "Ban Send [+n +ip]";

                case STType.FilterMessages:
                    return "Filter Messages [+n +x]";

                case STType.FilterContent:
                    return "Add/Remove Filters [+n +t +x]";

                case STType.Greetings:
                    return "Greet Messages [+n]";

                case STType.ChatHistory:
                    return "Chat History";

                case STType.Idling:
                    return "Idle Monitor [+n +t +d +h +m +s]";

                case STType.Linking:
                    return "Linking [+n +r +h]";

                case STType.MuzzleMessages:
                    return "Muzzle Messages [+n +t]";

                case STType.RejectionMessages:
                    return "Rejection Messages [+n]";

                case STType.PMBlocking:
                    return "PM Blocking [+n]";

                case STType.URL:
                    return "URL Tags [+n]";

                case STType.Vrooms:
                    return "Vrooms [+n +v]";

                case STType.Whowas:
                    return "Whowas [+n +v +e +l +t +q]";

                case STType.LastSeen:
                    return "Last Seen [+n +x +ip]";

                case STType.Trace:
                    return "IP Trace [+x]";

                case STType.UrbanDictionary:
                    return "Urban Dictionary [+x]";

                case STType.DictionaryDefine:
                    return "Dictionary Definition [+x]";

                case STType.Roomsearch:
                    return "Room Search [+n +t +l +s +u +h +x]";

                case STType.BanStats:
                    return "Ban Stats [+n +ip +x]";

                case STType.ClockTopic:
                    return "Clock Topic [+t +c]";

                case STType.Cloak:
                    return "Cloak [+n]";

                case STType.RoomInformation:
                    return "Room Information [+x]";

                case STType.Stats:
                    return "Stats [+x]";

                case STType.Whois:
                    return "Whois [+x]";

                case STType.Info:
                    return "Info [+id +n +v]";

                case STType.FilterList:
                    return "Filter List [+id +t +x]";

                case STType.BanList:
                    return "Ban List [+id +n +ip]";

                case STType.RangeBanList:
                    return "Range Ban List [+id +ip]";

                case STType.IPSend:
                    return "IP Send [+n +eip +lip +v +p]";

                case STType.VSpy:
                    return "VSpy [+n +v +ip +f +t]";

                case STType.Captcha:
                    return "Captcha";

                default:
                    return String.Empty;
            }
        }
    }

    class STObj
    {
        public STType Type { get; set; }
        public int Index { get; set; }
        public String Text { get; set; }
    }

    class STCell
    {
        public STType Type { get; set; }
        public int Index { get; set; }
    }

    enum STType : int
    {
        AdminList = 0,
        EnableDisable = 1,
        AdminMessages = 2,
        AdminCommands = 3,
        AdminLogin = 4,
        BanSend = 5,
        FilterMessages = 6,
        FilterContent = 7,
        Greetings = 8,
        ChatHistory = 9,
        Idling = 10,
        Linking = 11,
        MuzzleMessages = 12,
        RejectionMessages = 13,
        PMBlocking = 14,
        URL = 15,
        Vrooms = 16,
        Whowas = 17,
        LastSeen = 18,
        Trace = 19,
        UrbanDictionary = 20,
        DictionaryDefine = 21,
        Roomsearch = 22,
        BanStats = 23,
        ClockTopic = 24,
        Cloak = 25,
        RoomInformation = 26,
        Stats = 27,
        Whois = 28,
        Info = 29,
        FilterList = 30,
        BanList = 31,
        RangeBanList = 32,
        IPSend = 33,
        VSpy = 34,
        Captcha = 35
    }
}
