﻿using System;
using System.Collections.Generic;

namespace CallistoX
{
    class ThreadSafeList<T>
    {
        private List<T> list = new List<T>();

        public T[] Get()
        {
            T[] results;

            lock (this.list)
            {
                int size = this.list.Count;
                results = new T[size];

                if (size > 0)
                {
                    Array.Copy(this.list.ToArray(), results, size);
                    this.list.RemoveRange(0, size);
                }
            }

            return results;
        }

        public void Add(T item)
        {
            lock (this.list)
                this.list.Add(item);
        }
    }
}
