﻿using System;
using System.Collections.Generic;
using ICallisto;

namespace CallistoX
{
    class VSpy
    {
        private static List<int> items = new List<int>();

        public static void AddUser(IUser userobj)
        {
            if (!items.Contains(userobj.Id) && userobj.Level >= CmdLevelManager.GetLevel(Cmd.vspy))
            {
                items.Add(userobj.Id);

                if (StringTemplate.GetString(STType.AdminMessages, 18) != null)
                    Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 18).Replace("+n", userobj.Name), true);
            }
        }

        public static void RemoveUser(IUser userobj, bool parted)
        {
            if (items.RemoveAll(x => x == userobj.Id) > 0)
                if (!parted)
                    if (StringTemplate.GetString(STType.AdminMessages, 19) != null)
                        Callisto.PrintToAdmins(StringTemplate.GetString(STType.AdminMessages, 19).Replace("+n", userobj.Name), true);
        }

        public static void OnJoin(IUser userobj)
        {
            String str = StringTemplate.GetString(STType.VSpy, 0);

            if (str != null)
                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (items.Contains(u.Id))
                        if (u.Level >= CmdLevelManager.GetLevel(Cmd.vspy))
                            if (u.Vroom != userobj.Vroom)
                                Callisto.Print(u, str.Replace("+n", userobj.Name).Replace("+v", userobj.Version).Replace("+ip", userobj.ExternalIP.ToString()).Replace("+f", userobj.FileCount.ToString()));
        }

        public static void OnPart(IUser userobj)
        {
            String str = StringTemplate.GetString(STType.VSpy, 1);

            if (str != null)
                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (items.Contains(u.Id))
                        if (u.Level >= CmdLevelManager.GetLevel(Cmd.vspy))
                            if (u.Vroom != userobj.Vroom)
                                Callisto.Print(u, str.Replace("+n", userobj.Name).Replace("+v", userobj.Version).Replace("+ip", userobj.ExternalIP.ToString()).Replace("+f", userobj.FileCount.ToString()));
        }

        public static void OnText(IUser userobj, String text)
        {
            String str = StringTemplate.GetString(STType.VSpy, 2);

            if (str != null)
                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (items.Contains(u.Id))
                        if (u.Level >= CmdLevelManager.GetLevel(Cmd.vspy))
                            if (u.Vroom != userobj.Vroom)
                                Callisto.Print(u, str.Replace("+n", userobj.Name).Replace("+v", userobj.Version).Replace("+ip", userobj.ExternalIP.ToString()).Replace("+f", userobj.FileCount.ToString()).Replace("+t", text));
        }

        public static void OnEmote(IUser userobj, String text)
        {
            String str = StringTemplate.GetString(STType.VSpy, 3);

            if (str != null)
                for (IUser u = Callisto.FirstUser; u != null; u = u.NextUser)
                    if (items.Contains(u.Id))
                        if (u.Level >= CmdLevelManager.GetLevel(Cmd.vspy))
                            if (u.Vroom != userobj.Vroom)
                                Callisto.Print(u, str.Replace("+n", userobj.Name).Replace("+v", userobj.Version).Replace("+ip", userobj.ExternalIP.ToString()).Replace("+f", userobj.FileCount.ToString()).Replace("+t", text));
        }
    }
}
